package fr.plil.sio.examen.api;

import java.io.Serializable;
import java.util.LinkedList;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

/**
 * An animal must have a name one and only one owner
 */
@Entity
public class Animal implements Serializable {
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    
    @Column(nullable = false)
    private String name;

    @ManyToOne(optional = false)
    private Owner owner;
    
    @OneToMany(mappedBy = "reporter")
    List<Comment> comments = new LinkedList<>();
    
    
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Owner getOwner() {
        return owner;
    }

    public void setOwner(Owner owner) {
        this.owner = owner;
    }
    
    public List<Comment> getComments(){
        return this.comments;
    }
    
    public void setComments(List<Comment> comments){
        this.comments = comments;
    }
    
    
}
