package fr.plil.sio.examen.api;

import java.util.LinkedList;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

/**
 * An owner has a name and zero, one or more animals.
 */
@Entity
public class Owner {
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    
    @Column(nullable = false)    
    private String name;

    @OneToMany(mappedBy = "owner")
    private List<Animal> animals = new LinkedList<>();
    
    @OneToMany(mappedBy = "reporter")
    private List<Comment> comments = new LinkedList<>();
    
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Animal> getAnimals() {
        return animals;
    }

    public void setAnimals(List<Animal> animals) {
        this.animals = animals;
    }
    
    public List<Comment> getComments(){
        return this.comments;
    }
    
    public void setComments(List<Comment> comments){
        this.comments = comments;
    }
}
